from simudator.core.module import Module
from simudator.core.modules.memory import Memory
from simudator.core.processor import Processor
from simudator.core.signal import Signal
from simudator.processor.mia.modules.lc import LC


class DummyModule(Module):
    def __init__(self):
        self.name = "name"
        self.a = 4
        self.b = "a"
        self.c = [1, 2, 3]

    def reset(self):
        self.name = "dummy"
        self.a = 0
        self.b = ""
        self.c = []

    def get_state(self):
        return {
            "name": self.name,
            "a": self.a,
            "b": self.b,
            "c": self.c,
        }

    def output_register(self):
        pass

    def update_logic(self):
        pass


def test_reset():
    cpu = Processor()
    cpu._signal_history = ["this", "should", "be", "removed"]
    dummy = DummyModule()
    cpu._clock = 100
    cpu._removed_cycles = 1337
    cpu._module_history.append(dummy.get_state())
    cpu._signal_history.clear()
    cpu._removed_cycles = 0
    cpu._assembly_cycles = [i for i in range(9)]
    cpu.add_module(dummy)
    cpu.reset()
    assert dummy.name == "dummy"
    assert dummy.a == 0
    assert dummy.b == ""
    assert dummy.c == []
    assert cpu._clock == 0
    assert cpu._removed_cycles == 0
    assert cpu._module_history == []
    assert cpu._signal_history == []
    assert cpu._assembly_cycles == [0]
